var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { promises as fsPromises } from "fs";
function generateHtmlFiles(_a) {
    var _b = _a.publicDir, publicDir = _b === void 0 ? "/dist/" : _b, jsEntryFile = _a.jsEntryFile, cssEntryFile = _a.cssEntryFile, _c = _a.output, output = _c === void 0 ? [] : _c, _d = _a.chunks, chunks = _d === void 0 ? [] : _d;
    if (!jsEntryFile) {
        throw new Error("Configuration error: 'jsEntryFile' is required.");
    }
    if (!cssEntryFile) {
        throw new Error("Configuration error: 'cssEntryFile' is required.");
    }
    if (!Array.isArray(output)) {
        throw new Error("Configuration error: 'output' must be an array.");
    }
    var defaultScriptElementAttributes = ['type="module"'];
    var defaultLinkElementAttributes = ['media="all"'];
    return {
        name: "vite-plugin-generate-html",
        generateBundle: function (_options, bundle) {
            return __awaiter(this, void 0, void 0, function () {
                var entryScripts, scripts, error_1, links, error_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            entryScripts = Object.values(bundle)
                                .filter(function (chunk) { return chunk.type === "chunk" && chunk.isEntry; })
                                .filter(function (chunk) {
                                if (chunks.length > 0) {
                                    return chunk.name && chunks.includes(chunk.name);
                                }
                                return true;
                            });
                            if (entryScripts.length === 0) {
                                throw new Error("No application entry points found. Please define at least one entry point in your Vite configuration.");
                            }
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            scripts = entryScripts
                                .map(function (chunk) {
                                // Use default attributes if no output configuration is provided
                                if (output.length === 0) {
                                    return "<script ".concat(defaultScriptElementAttributes.join(" "), " src=\"").concat(publicDir).concat(chunk.fileName, "\"></script>");
                                }
                                // Find matching entry in the output configuration
                                var matchingEntry = output.find(function (entry) { return entry[chunk.name]; });
                                if (!matchingEntry) {
                                    throw new Error("Output configuration error: No matching key found for entry point \"".concat(chunk.name, "\"."));
                                }
                                var scriptElementAttributes = matchingEntry[chunk.name].attrs;
                                if (!Array.isArray(scriptElementAttributes)) {
                                    throw new Error("Output configuration error: 'attrs' for entry point \"".concat(chunk.name, "\" must be an array."));
                                }
                                return "<script ".concat(scriptElementAttributes.join(" "), " src=\"").concat(publicDir).concat(chunk.fileName, "\"></script>");
                            })
                                .join("\n");
                            return [4 /*yield*/, fsPromises.writeFile(jsEntryFile, scripts)];
                        case 2:
                            _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            error_1 = _a.sent();
                            if (error_1 instanceof Error) {
                                throw new Error("Failed to write <script> elements to '".concat(jsEntryFile, "': ").concat(error_1.message));
                            }
                            throw new Error("Failed to write <script> elements to '".concat(jsEntryFile, "'."));
                        case 4:
                            _a.trys.push([4, 6, , 7]);
                            links = entryScripts
                                .filter(function (chunk) { return chunk.viteMetadata.importedCss.size > 0; })
                                .map(function (chunk) {
                                var linkAttrs = defaultLinkElementAttributes;
                                // Find matching entry in the output configuration
                                var matchingEntry = output.find(function (entry) { return entry[chunk.name]; });
                                if (matchingEntry) {
                                    if (!Array.isArray(matchingEntry[chunk.name].linkAttrs)) {
                                        throw new Error("Output configuration error: 'linkAttrs' for entry point \"".concat(chunk.name, "\" must be an array."));
                                    }
                                    linkAttrs = matchingEntry[chunk.name].linkAttrs;
                                }
                                return Array.from(chunk.viteMetadata.importedCss)
                                    .map(function (fileName) {
                                    return "<link href=\"".concat(publicDir).concat(fileName, "\" rel=\"stylesheet\" ").concat(linkAttrs.join(" "), " />");
                                })
                                    .join("\n");
                            })
                                .join("\n");
                            return [4 /*yield*/, fsPromises.writeFile(cssEntryFile, links)];
                        case 5:
                            _a.sent();
                            return [3 /*break*/, 7];
                        case 6:
                            error_2 = _a.sent();
                            if (error_2 instanceof Error) {
                                throw new Error("Failed to write <link> elements to '".concat(cssEntryFile, "': ").concat(error_2.message));
                            }
                            throw new Error("Failed to write <link> elements to '".concat(cssEntryFile, "'."));
                        case 7: return [2 /*return*/];
                    }
                });
            });
        },
    };
}
export default generateHtmlFiles;
//# sourceMappingURL=index.js.map